<template lang="pug">
.home
  .promo-wrapper(
    :style="stylePromoWrapper")
    .container.promo-wrapper__text(
      ref='promo-text')
      h1.promo-heading.home__heading(
        :style="styleTextPromo"
        v-html="home.page.heading")
      p.home__subheading(
        :style="styleTextPromo"
        v-html="home.page.text")

  .home__about.container-fluid(style="padding-bottom:0")
    .row
      .col-xl-6.col-md-12.home__about-text-wrapper
        h2.promo-heading.promo-heading_main-content.home__about-heading Немного о нас
        p.promo-text_main-content.home__about-text
          | АО «Шувалово» - крупнейшее мясоперерабатывающее предприятие в Костромской области замкнутого цикла со своей сырьевой базой, самым современным и высокотехнологичным оборудованием.
        .button-wrapper
          nuxt-link.nuxt-button-link(to="/about") Читать больше
            font-awesome-icon.nuxt-button-link__icon(icon="angle-right")
      .col-xl-6.col-md-12.home__about-poster-wrapper
        .home__about-poster
          app-image-item(
            source="/img/home/about.jpg"
            alt="Ангар в поле")

  <!--.home__video.container-fluid-->
    <!--.home__video-wrapper-->
      <!--app-image-item(-->
        <!--source="/img/home/video-poster.jpg"-->
        <!--alt="Коровы на выпасе")-->
      <!--.home__video-text-wrapper-->
        <!--h2.promo-heading.promo-heading_main-content.home__video-heading Шувалово филмс-->
        <!--.button-wrapper.white.no-border-->
          <!--button.nuxt-button-link Смотреть-->
            <!--font-awesome-icon.nuxt-button-link__icon(icon="angle-right")-->

  .home__appeal.container
    .row
      .col-12
        h2.visually-hidden Обращение акционера
        .home__appeal-wrapper
          .home__appeal-user
            app-image-item(
              source="/img/home/user.jpg"
              alt="Комин Владимир Вадимович")
          h3.home__appeal-name Комин Владимир Вадимович
          span.home__appeal-position Председатель совета директоров
          p.home__appeal-text.promo-text_main-content
            |АО «Шувалово» с 1970 года на рынке и стало одним из самых узнаваемых брендов Костромского мяса, колбас и полуфабрикатов.

  .promo-cover.production-cycle.container-fluid
    h2.promo-heading.promo-heading_main-content.promo-cover__heading.promo-cover__heading_white Полный
      br
      | цикл производства

  .home__production.container-fluid
    ol.home__production-list.row

      li.home__production-list-item.col-xl-6.col-lg-12.corn
        .home__production-list-text
          h3.home__production-list-heading Производство кормов
          p.home__production-list-description АО «Шувалово» уделяет особое внимание кормам, ведь от них зависит здоровье животного и, как следствие, качество мяса и продукции.

      li.home__production-list-item.col-xl-6.col-lg-12.pigs
        .home__production-list-text
          h3.home__production-list-heading Свиноводство
          p.home__production-list-description Суммарный годовой объем выращивания свинины на 3 площадках составляет 50000 голов.

      li.home__production-list-item.col-xl-6.col-lg-12.ham
        .home__production-list-text
          h3.home__production-list-heading Мясопереработка
          p.home__production-list-description Прямо с площадок, где выращиваются животные, свиньи и КРС поступают в АПК «По переработке КРС и свиней».

      li.home__production-list-item.col-xl-6.col-lg-12.sausage
        .home__production-list-text
          h3.home__production-list-heading Производство колбас
          p.home__production-list-description Из «АПК по переработке КРС и свиней» свиные и говяжьи полутуши отправляются по галерее в колбасный цех, где и происходит процесс изготовления колбасы и полуфабрикатов.

      li.home__production-list-item.col-xl-6.col-lg-12.counter
        .home__production-list-text
          h3.home__production-list-heading Розничная продажа
          p.home__production-list-description Из колбасного цеха продукция поступает на склад экспедиции, откуда она доставляется в более, чем 30  торговых точек собственной сети и 70% сетевых магазинов Костромы.

      .col-xl-6.col-lg-12.more-list__wrapper
        .button-wrapper
          nuxt-link.nuxt-button-link(to="/about/production") Узнать больше
            font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

  .home__category(v-if="sliderData")
    .home__category-text-wrapper
      h2.promo-heading.promo-heading_main-content.home__category-heading Наш продукт
      p.promo-text_main-content.home__category-text
        | Ассортимент АО «Шувалово» включает в себя свиные полутуши, более 100 видов колбас, сосисок, сарделек и порядка 50 видов деликатесов и полуфабрикатов.
      .button-wrapper.white-bg
        nuxt-link.nuxt-button-link(to="/catalog") В каталог
          font-awesome-icon.nuxt-button-link__icon(icon="angle-right")
    div(
      v-if="sliderView"
      v-swiper:myswiper='swiperOption')
      .swiper-wrapper
        .swiper-slide(v-for='category in sliderData')
          img.swiper-photo(
            :src="category.photo"
            :alt="category.name")
          h4.swiper-heading {{ category.name }}
      .swiper-pagination.swiper-pagination-bullets


  .home__news.container-fluid(v-if='home.news.length')
    .row.flex-row-reverse
      .col-xl-5.col-lg-12.home__news-text
        h2.promo-heading.promo-heading_main-content.home__news-heading Наши новости
        .button-wrapper
          nuxt-link.nuxt-button-link(to="/news") Читать все
            font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

      .col-xl-7.col-lg-12.home__news-wrapper

        app-news.home__news-item(
          v-for="item in home.news"
          :cover="item.cover"
          :heading="item.heading"
          :time="item.created_at"
          :slug="item.slug"
          :key="item.id")

  .promo-cover.work-with-us.container-fluid
    .promo-cover__wrapper
      h2.promo-heading.promo-heading_main-content.promo-cover__heading.promo-cover__heading_white Работа у нас
      .button-wrapper.white.no-border
        nuxt-link.nuxt-button-link(to="/about/vacancies") Все вакансии
          font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

  .home__awards.container-fluid
    .row
      .col-xl-5.col-lg-12.home__awards-text-wrapper
        h2.promo-heading.promo-heading_main-content.home__awards-heading Наши награды
        .home__awards-text-inner-wrapper
          p.promo-text_main-content.home__awards-text
            | Наша компания — постоянный участник и победитель международных, российских и региональных выставок, ярмарок и конкурсов.
          .button-wrapper
            nuxt-link.nuxt-button-link(to="/about") О компании
              font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

      ul.col-xl-7.col-lg-12.home__awards-list
        li.home__awards-list-item
          img.home__awards-list-photo(
            src="/img/home/awards/2003.png"
            alt="Медаль «Золотая осень-2003»")
          .home__awards-list-text
            h3.home__awards-list-heading «Золотая осень-2003»
            p.home__awards-list-description Лучшая продовольственная продукция

        li.home__awards-list-item
          img.home__awards-list-photo(
            src="/img/home/awards/2004.png"
            alt="Медаль «Регионы России-2004»")
          .home__awards-list-text
            h3.home__awards-list-heading «Регионы России-2004»
            p.home__awards-list-description Лучший отечественный товар

        li.home__awards-list-item
          img.home__awards-list-photo(
            src="/img/home/awards/2006.png"
            alt="Медаль «Мясная индустрия-2006»")
          .home__awards-list-text
            h3.home__awards-list-heading «Мясная индустрия-2006»
            p.home__awards-list-description Конкурс качества мясной продукции

        li.home__awards-list-item
          img.home__awards-list-photo(
            src="/img/home/awards/500.png"
            alt="Медаль «500 лучших предприятий»")
          .home__awards-list-text
            h3.home__awards-list-heading «500 лучших предприятий»
            .home__awards-list-description Российский деловой реестр

        li.home__awards-list-item
          img.home__awards-list-photo(
            src="/img/home/awards/gold.png"
            alt="Медаль «Золотая осень-2010»")
          .home__awards-list-text
            h3.home__awards-list-heading «Золотая осень-2010»
            p.home__awards-list-description Лучший отечественный товар

  .home__partners.container-fluid
    h2.promo-heading.promo-heading_main-content.home__partners-heading Наши партнеры

    .home__partners-logo

      .home__partners-logo-item
        img(src="/img/home/partners/logo-10ka.png" alt="Десяточка")
      .home__partners-logo-item
        img(src="/img/home/partners/liga.png" alt="Высшая лига")
      .home__partners-logo-item
        img(src="/img/home/partners/gulliver.png" alt="Гулливер")
      .home__partners-logo-item
        img(src="/img/home/partners/lider.png" alt="Лидер")

    yandex-map(
      id='card'
      v-if='mapView'
      :coords='mainCoords'
      :zoom='mainZoom'
      :scroll-zoom='false'
      :controls="['zoomControl', 'fullscreenControl']"
      :style='`width: 100%; height: ${yaMapHeight};`'
      :cluster-options='{1: {clusterDisableClickZoom: true}}'
      map-type='map')

      ymap-marker(
        v-for='marker in markersArray'
        :key='marker.id'
        :marker-id='marker.id'
        marker-type='placemark'
        :coords='marker.coords'
        :hint-content='marker.balloon.header'
        :balloon="marker.balloon"
        :icon="marker.icon"
        cluster-name='1')
    .button-wrapper
      nuxt-link.nuxt-button-link(to="/cooperation") Подробнее
        font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

  .promo-cover.sharers.container-fluid
    .promo-cover__wrapper
      h2.promo-heading.promo-heading_main-content.promo-cover__heading.promo-cover__heading_white Акционерам
      .button-wrapper.white.no-border
        nuxt-link.nuxt-button-link(to="/cooperation") Подробнее
          font-awesome-icon.nuxt-button-link__icon(icon="angle-right")

</template>

<script>
import { mapMutations } from 'vuex';

let ligaIcon = {
  layout: 'default#image',
  imageHref: 'img/home/partners/liga.png',
  imageSize: [60, 60],
  imageOffset: [-30, -30]
};
let tenIcon = {
  layout: 'default#image',
  imageHref: 'img/home/partners/logo-10ka.png',
  imageSize: [120, 20],
  imageOffset: [-60, -10]
};
let liderIcon = {
  layout: 'default#image',
  imageHref: 'img/home/partners/lider.png',
  imageSize: [90, 40],
  imageOffset: [-45, -20]
};
let gulliverIcon = {
  layout: 'default#image',
  imageHref: 'img/home/partners/gulliver.png',
  imageSize: [80, 40],
  imageOffset: [-40, -20]
};

import ligaItems from '../configs/partners/liga';
import tenItems from '../configs/partners/10ka';
import liderItems from '../configs/partners/lider';
import gulliverItems from '../configs/partners/gulliver';

import AppNews from '../components/public/NewsItem';
import ImageItem from '../components/public/ImageItem';

export default {
  name: 'Home',
  async asyncData({ app, store, params }) {
    let { data } = await app.$axios.get('/api/v1/home/public');
    return { home: data };
  },
  components: {
    'app-news': AppNews,
    'app-image-item': ImageItem
  },
  data() {
    return {
      sliderData: null,
      swiperOption: {
        loop: true,
        slidesPerView: 'auto',
        centeredSlides: true,
        spaceBetween: 0,
        pagination: {
          el: '.swiper-pagination',
          clickable: true
        },
        autoplay: {
          delay: 10000
        }
      },
      mapView: false,
      yaMapHeight: null,
      mainZoom: 13,
      mainCoords: [57.762854, 40.946466],
      markersArray: [],
      sliderView: false
    };
  },
  computed: {
    styleTextPromo() {
      let style = {};
      if (this.home) {
        style.color = this.home.page.promoTextColor;
      }
      return style;
    },
    stylePromoWrapper() {
      let style = {};
      if (this.home) {
        style['background-image'] = `url(${this.home.page.photo})`;
      }
      style['background-color'] = this.home.page.promoBackgroundColor;
      return style;
    }
  },
  created() {
    this.$store.state.menuColor = this.home.page.promoTextColor;
    if (ligaItems && ligaItems.length) {
      ligaItems.forEach((item, i) => {
        this.markersArray.push({
          id: `liga-${i + 1}`,
          coords: item.coords,
          balloon: {
            header: 'Высшая лига',
            body: item.adr
          },
          icon: ligaIcon
        });
      });
    }
    if (tenItems && tenItems.length) {
      tenItems.forEach((item, i) => {
        this.markersArray.push({
          id: `10ka-${i + 1}`,
          coords: item.coords,
          balloon: {
            header: 'Десяточка',
            body: item.adr
          },
          icon: tenIcon
        });
      });
    }
    if (liderItems && liderItems.length) {
      liderItems.forEach((item, i) => {
        this.markersArray.push({
          id: `lider-${i + 1}`,
          coords: item.coords,
          balloon: {
            header: 'Лидер',
            body: item.adr
          },
          icon: liderIcon
        });
      });
    }
    if (gulliverItems && gulliverItems.length) {
      gulliverItems.forEach((item, i) => {
        this.markersArray.push({
          id: `gulliver-${i + 1}`,
          coords: item.coords,
          balloon: {
            header: 'Гулливер',
            body: item.adr
          },
          icon: gulliverIcon
        });
      });
    }
    this.getCategiriesAndProductsForSlider();
  },
  mounted() {
    this.sliderView = true;
    this.mapView = true;
    this.SET_LOADING(false);
  },
  methods: {
    ...mapMutations(['SET_LOADING']),
    async getCategiriesAndProductsForSlider() {
      let data = await this.$axios.get('/api/v1/home/categories');
      try {
        if (data.data.categories.length) {
          this.sliderData = [];
          data.data.categories.forEach(item => {
            this.sliderData.push({
              name: item.name,
              slug: item.slug
            });
          });
        }
        if (data.data.products.length) {
          data.data.products.forEach(item => {
            let index = this.sliderData.findIndex(
              category => category.slug === item.category
            );
            this.sliderData[index].photo = item.photo;
          });
        }
      } catch (e) {
        console.log(e);
      }
    }
  }
};
</script>
